/**
 * Diese Datei ist Teil von „Lernstrategien“ 
 * (Dateiname: „mod_splernstrategien“), einer Plugin-Software 
 * für das moodle LMS.
 *
 * Das moodle LMS ist lizenziert mit der GNU General Public 
 * License Version 3. Aktuelle Lizenzhinweise zu moodle 
 * finden Sie unter: https://moodledev.io/general/license.
 *
 * Das Plugin ist lizenziert mit der GNU General Public 
 * License Version 3. Anzugebender Urheber des Plugins ist
 * die „metromorph softworks GmbH im Auftrag von ORCA.nrw“.
 * Die Lizenzierung umfasst nicht die Inhalte, die auf der
 * Anwenderoberfläche des Plugins angezeigt werden; diese sind 
 * ihrerseits CC BY-SA 4.0 lizenziert.
 *
 * Sie sollten eine Kopie der GNU-Lizenz zusammen mit diesem 
 * Programm erhalten haben. Sie finden sie auch unter 
 * https://www.gnu.org/licenses. Die CC-Lizenz finden Sie
 * unter https://creativecommons.org/licenses/by-sa/4.0/deed.de.
 */

/**
 * Stellt Videos nacheinander dar.
 *
 *
 * Wechsel erfolgt durch Klassenwechsel am Ende eines Videos
 * bzw. nach beantworten einer Frage im Formular
 *
 * @module    mod_splernstrategien
 * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */

define([],
    function() {
        var handleChange = function(e) {
            document.querySelectorAll('video').forEach(
                (item) => {
                    item.pause();
                }
            );
            /* Hide viewed video, show next one */
            if (e.target.closest('fieldset').nextElementSibling !== null &&
                e.target.closest('fieldset').nextElementSibling.tagName == "FIELDSET") {
                e.target.closest('div.onebyone').querySelectorAll('.show').forEach(
                    (element) => {
                        element.classList.remove('show');
                    }
                );
                e.target.closest('fieldset').nextElementSibling.classList.add('show');
                e.target.closest('fieldset').nextElementSibling.querySelector('video').play();
            } else {
                document.querySelector('div.notice').classList.remove('hidden');
            }
        };
        return {
            init: () => {
                document.querySelectorAll('.onebyone video').forEach(
                    (media) => {
                        media.addEventListener('ended', function(e) {
                            e.target.closest('fieldset.questionsfieldset').nextElementSibling.classList.add('show');
                        });
                    }
                );
                // Debug console.log(document.querySelector('.onebyone fieldset'));
                document.querySelector('.onebyone fieldset').classList.add('show');
                document.querySelectorAll('.onebyone input[data-change=next-video]').forEach(
                    (item) => {
                        item.addEventListener('change', handleChange);
                    }
                );
            }
        };
    }
);
